Author: Timo Dödtmann Category: I18n
Created: 2013-02-01 Assigned To:
Has patch: No
Complexity:
Affected Flow version: Flow 2.0.0 beta 1
Subject: TranslateViewHelper fails if an array with a single number is passed as arguments
Description

If the TranslateViewHelper will passed "arguments" and this is now an array of a single number [array(0 => 123)], for example to tell
that the password is too short, the Translator (\TYPO3\Flow\I18n\Translator) try's to find the plural form of this number (take a look in 
\TYPO3\Flow\I18n\Translator->translateById() which is called \TYPO3\Flow\I18n\Translator->getPluralForm()).
Normally this fails and the ViewHelper returns the passed "id" or "value".

The following line returns "Password must have x characters.", even if "myMessageId" is set correctly.

{f:translate(id:'myMessageId', arguments:{0:123}, value:'Password must have x characters.')}

If "myMessageId" use the placeholder {1} and

{f:translate(id:'myMessageId', arguments:{0:1, 1:123}, value:'Password must have x characters.')}

is called, then "myMessageId" wil be returned with "123" for the placeholder.

Related issues:
duplicated by TYPO3.Fluid - Bug # 46092: The f:translate ViewHelper does noth... Resolved 2013-03-07
duplicated by TYPO3.Flow - Bug # 49545: Non-plural translations are not found... Closed 2013-07-01

Associated revisions
Revision 98748f8b - 2014-02-24 11:58 - Alexander Berl

[!!!][BUGFIX] Translation not working with single numeric argument

This removes the option to provide the plural quantity as a single numeric
argument, as this was used nowhere but prevented translations from working
with such single arguments.

This change is breaking for cases where an application depends on previous
behavior that translateBy* calls with a single numeric argument would implicate
a quantity for plural form. Also classes extending I18n\Translator and using
protected method getPluralForm() will break due to a signature change.

Change-Id: I12e0856e7251684e6240c4350f4571c2207d769b
Fixes: #45062
Releases: master, 2.1
Revision 79e26ae9 - 2014-02-24 11:59 - Alexander Berl

[!!!][BUGFIX] Translation not working with single numeric argument

This removes the option to provide the plural quantity as a single numeric
argument, as this was used nowhere but prevented translations from working
with such single arguments.

This change is breaking for cases where an application depends on previous
behavior that translateBy* calls with a single numeric argument would implicate
a quantity for plural form. Also classes extending I18n\Translator and using
protected method getPluralForm() will break due to a signature change.

Change-Id: I12e0856e7251684e6240c4350f4571c2207d769b
Fixes: #45062
Releases: master, 2.1

History
#1 - 2013-04-24 11:03 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20130

#2 - 2013-04-24 11:08 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20130

#3 - 2013-04-26 22:56 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20130

#4 - 2013-06-17 12:11 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20130

#5 - 2013-06-21 17:29 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20130

#6 - 2013-07-04 09:24 - Adrian Föder
- Project changed from TYPO3.Fluid to TYPO3.Flow
- Category deleted (ViewHelpers)

moved to TYPO3.Flow as this is more appropriate

#7 - 2013-07-04 09:25 - Adrian Föder
- Category set to I18n

#8 - 2014-02-24 11:58 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/20130

#9 - 2014-02-24 11:59 - Gerrit Code Review

Patch set 1 for branch 2.1 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/27811

#10 - 2014-02-24 12:36 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:98748f8b10bf6746daa2594dc069ff0b473982de.
